package SOFA.demos.cplayer;

public class ControllerImpl implements Runnable {
  SOFA.Component.DCUP.DCUPComponentManagerImpl cm;

  ControlInterface controlRequirment;
  boolean end;
  boolean stopped;

  public ControllerImpl(SOFA.Component.DCUP.DCUPComponentManagerImpl _cm) {
    cm = _cm;
    end = false;
    stopped = false;
  }

  private void setRequirement() throws SOFA.Component.NamingException {
    controlRequirment = (ControlInterface) cm.getRequirement("control");
  }

  public void run() {
    try {
      setRequirement();
    } catch (SOFA.Component.NamingException e) {
      throw new SOFA.SOFAnode.Run.SOFARuntimeException("Bad requirements", e);
    }
    while (!end) {
      controlRequirment.play();
      try {
        Thread.currentThread().sleep(1000);
      } catch (Exception e) {
        ;
      }
      controlRequirment.stop();
      try {
        Thread.currentThread().sleep(1000);
      } catch (Exception e) {
        ;
      }
    }
    stopped = true;
  }

  public void setEnd() {
    end = true;
  }

  public boolean isStopped() {
    return stopped;
  }
}
